## CASAviewer 

The CASA viewer has been built and distributed as part of [CASA](http://casa.nrao.edu/) for many years. This repository makes it possible to build the CASA viewer without building the rest of CASA. At some point in the near future, CASAviewer (built from this repository) will become the default viewer for CASA distributions. It will be included directly in the distribution for some time to come, but eventually users will be able to chose between the [CASAviewer](https://open-bitbucket.nrao.edu/projects/CASA/repos/casaviewer/browse) and [CARTA](https://cartavis.github.io).

## Building

On [macOS](https://www.apple.com/macos/), this builds a [macOS App](https://developer.apple.com/library/content/documentation/CoreFoundation/Conceptual/CFBundles/DocumentPackages/DocumentPackages.html#). On [linux](https://en.wikipedia.org/wiki/Linux), it builds an [AppImage](https://appimage.org). In both cases, this is accomplished with [qmake](http://doc.qt.io/qt-5/qmake-manual.html) supplemented with some [Java](https://en.wikipedia.org/wiki/Java_(programming_language)) tools (fetched from [NRAO](http://www.nrao.edu/)) and the [AppImage](https://appimage.org) packaging program (on Linux).

This is designed to build with Qt 4.8.* It may build with Qt 5.*, but this has not been tested and may result in GUI layout problems. To build this, some prerequsites must be installed (a subset of the standard CASA third-party package suite). If you need to install these, take a look [here](https://open-bitbucket.nrao.edu/projects/CASA/repos/casatools/browse) for some hints.

#### Checkout

Checkout the CASAviewer source code:

```
-bash-4.2$ git clone -q --recursive https://open-bitbucket.nrao.edu/scm/casa/CASAviewer.git
```

#### Build

After the CASA build environment is installed, the CASAviewer can be built like:
```
-bash-4.2$ cd CASAviewer
-bash-4.2$ type qmake
qmake is /opt/local/libexec/qt4/bin/qmake
-bash-4.2$ qmake
-bash-4.2$ make
```
This will create a `build` subdirectory. The `build` subdirectory will contain a `bin.*` directory. On OSX, this will contain an OSX application directory, and on Linux, it will contain an AppImage. For OSX builds, an additional script (`scripts/create-dmg`) is available to create the final, packaged dmg containing the CASAviewer OSX app.

The Python `casaviewer` package can be built like:
```
-bash-4.2$ make py
```
after the casaviewer application has been built.
